#!/bin/perl

#####################################
#                                   #
# RobLog Version 4.02               #
# Copyright 1998 by Rob Eisler      #
# rob@robplanet.com                 #
# http://www.robplanet.com          #
#                                   #
# Last modified on May 27, 1998     #
#                                   #
#####################################
#
# Copyright Notice:
# Copyright 1998 Robert S. Eisler.  All Rights Reserved.
#
# This code may be used and modified by anyone so long as this header and
# copyright information remains intact.  By using this code you agree to 
# indemnify Robert S. Eisler from any liability that might arise from its 
# use.  You must obtain written consent before selling or redistributing 
# this code.  
#
# You should have received the file readme.txt with this distribution.
# If not, please let me know where you obtained this copy of RobLog by
# sending mail to eislerr@tdi.uregina.ca .  The newest version of
# readme.txt is always available at:
# http://tdi.uregina.ca/~eislerr/cgi/roblog/readme.txt
# Please see this file for further information.
#
#####################################

## These are the variables you need to set ##

$date = '/bin/date';
$logdir = '/path/to/your/roblog/directory';
$logurl = 'http://www.yourhost.com/~your/roblog';
@referers = ('www.ignore_my_hits.com','999.888.777.6');
$timeoffset = 0;

#########################################################################
# Don't change anything below here unless you know what you're doing :) #
#########################################################################

$use_cgi = 1;

print "Content-type: text/html\n\n";

print "<!-- RobLog v4.02 Copyright 1998 Robert Eisler -->\n";
print "<!-- http://tdi.uregina.ca/~eislerr/cgi/roblog/index.html -->\n\n";
print "<!-- RobLog v4.02 Starting Now! -->\n";

&check_url;
&get_date;
&get_data;
&hour;
&weekday;
&ip if ($ENV{REMOTE_ADDR});
&browser if ($ENV{HTTP_USER_AGENT});
&os if ($ENV{HTTP_USER_AGENT});
&referer if ($ENV{HTTP_REFERER});
&server if ($ENV{REMOTE_HOST});
&log;
&index;

print "<!-- RobLog v4.02 Successfully Completed! -->\n\n";

exit;

sub hour {

# get old hour data

open(FILE, "$logdir/hour.txt") || &file_open_error("hour.txt");

@hourinfo = <FILE>;
close(FILE);
$numhour = @hourinfo;

($h0,$h1,$h2,$h3,$h4,$h5,$h6,$h7,$h8,$h9,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23,$hdate) = split(/``/,$hourinfo[0]);
@h = ($h0,$h1,$h2,$h3,$h4,$h5,$h6,$h7,$h8,$h9,$h10,$h11,$h12,$h13,$h14,$h15,$h16,$h17,$h18,$h19,$h20,$h21,$h22,$h23);

$total = 0;

# add 1 to the current hour

for ($a = 0; $a <= 23; $a++) {

	if ($savehour == $a) {
		$h[$a] = $h[$a] + 1;
	}

	$total = $total + $h[$a];

}

# get percent, graph width

for ($a = 0; $a <= 23; $a++) {

	$hp[$a] = sprintf("%.2f", ($h[$a]/$total) * 100);
	$g[$a] = int(5*$hp[$a])+1;

}

# write hour html file

open(FILE, ">$logdir/hour.html") || &file_open_error("hour.html");

&header("Hits by Hour");
print FILE "<font face=\"comic sans ms\" size=0 color=black>Hourly stats reset on $hdate\.</font><p>\n";
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
print FILE "<tr><th>HOUR</th>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th></tr>\n";

for ($a = 0; $a <= 23; $a++) {

	$temp = $a + 1;
	
	print FILE "<tr><th>$a:00 - $temp:00</th>";
	print FILE "<td align=center>$h[$a]</td>"; 
	print FILE "<td align=center>$hp[$a]%</td>";
	print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
	print FILE "width=\"$g[$a]\"></td></tr>\n";

}

print FILE "<tr><th>TOTAL</th>";
print FILE "<th>$total</th><th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n"; 
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</font></center></body></html>\n";

close(FILE);

# write hour data

open(FILE, ">$logdir/hour.txt") || &file_open_error("hour.txt");

for ($a = 0; $a <= 23; $a++) {
	print FILE "$h[$a]``";
}
print FILE "$hdate";

close(FILE);

print "<!-- Finished with hour.html -->\n";

} # end sub hour

sub weekday {

# get old weekday data

open(FILE, "$logdir/weekday.txt") || &file_open_error("weekday.txt");

@info = <FILE>;
close(FILE);
$numinfo = @info;

($sun, $mon, $tue, $wed, $thu, $fri, $sat, $wdate) = split(/``/,$info[0]);
@d = ($sun,$mon,$tue,$wed,$thu,$fri,$sat);
$total = 0;

# add 1 to current day

for ($a = 0; $a <= 6; $a++) {

	if ($wday == $a) {
		$d[$a] = $d[$a] + 1;
	}
	$total = $total + $d[$a];

}

# get percent, graph width

for ($a = 0; $a <= 6; $a++) {

	$dp[$a] = sprintf("%.2f", ($d[$a]/$total) * 100);
	$g2[$a] = int(5*$dp[$a]) + 1;

}

# write weekday html file

open(FILE, ">$logdir/weekday.html") || &file_open_error("weekday.html");

&header("Hits by Weekday");
print FILE "<font face =\"comic sans ms\" size=0 color=black>Weekday stats reset on $wdate\.</font><p>\n";
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
print FILE "<tr><th>DAY</th>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th>\n";

for ($a = 0; $a <= 6; $a++) {

	print FILE "<tr><th>$days[$a]</th>";
	print FILE "<td align=center>$d[$a]</td>"; 
	print FILE "<td align=center>$dp[$a]%</td>";
	print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
	print FILE "width=\"$g2[$a]\"></td></tr>\n";

}

print FILE "<tr><th>TOTAL</th>";
print FILE "<th>$total</th>";
print FILE "<th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n"; 
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n"; 
print FILE "</font></center></body></html>\n";

close(FILE);

# write weekday data

open(FILE, ">$logdir/weekday.txt") || &file_open_error("weekday.txt");

for ($a = 0; $a <= 6; $a++) {
	print FILE "$d[$a]``";
}

print FILE "$wdate";

close(FILE);

print "<!-- Finished with weekday.html -->\n";

} # end sub weekday

sub ip {

# get old ip data

open(FILE, "$logdir/ip.txt") || &file_open_error("ip.txt");

@ipinfo = <FILE>;
close(FILE);
$numip = @ipinfo;
($newip, $xxx, $yyy, $zzz) = split(/\./,$ENV{REMOTE_ADDR});
$ipfound = 0;
$total = 0;

# add 1 to current ip

for ($a = 0; $a < $numip; $a++) {

   ($ipaddr[$a], $ipcount[$a], $nochop) = split(/``/,$ipinfo[$a]);

   if ($ipaddr[$a] == $newip) {
      $ipcount[$a] ++;
      $ipfound = 1;
   }

   $total = $total + $ipcount[$a];

}

# if this ip is new, create a new piece of data for it

if ($ipfound == 0) {
   $ipaddr[$numip] = $newip;
   $ipcount[$numip] = 1;
   $numip++;
   $total++;
}

# the famous "Gugliotta Bubliotta" sort

for ($a = 0; $a < $numip; $a++) {
   for ($b = ($numip - 1); $b > $a; $b--) {

      if ($ipcount[$b] > $ipcount[$b-1]) {
         $temp1 = $ipaddr[$b-1];
         $ipaddr[$b-1] = $ipaddr[$b];
         $ipaddr[$b] = $temp1;
         $temp2 = $ipcount[$b-1];
         $ipcount[$b-1] = $ipcount[$b];
         $ipcount[$b] = $temp2;
      }

   }
}

# get percent, graph width

for ($a = 0; $a < $numip; $a++) {

	$ipp[$a] = sprintf("%.2f", ($ipcount[$a]/$total) * 100);
	$ipg[$a] = int(5*$ipp[$a]) + 1;

}

# write ip html file

open(FILE, ">$logdir/ip.html") || &file_open_error("ip.html");

&header("Hits by IP");
print FILE "<font face=\"comic sans ms\" size=0 color=black>IP stats reset on $ipdate\.</font><p>\n";
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
print FILE "<tr><th>IP</th>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th>\n";

for ($a = 0; $a < $numip; $a++) {

	if ($ipcount[$a] > 1) {

		print FILE "<tr><th>$ipaddr[$a]</th>";
		print FILE "<td align=center>$ipcount[$a]</td>"; 
		print FILE "<td align=center>$ipp[$a]%</td>";
		print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
		print FILE "width=\"$ipg[$a]\"></td></tr>\n";

	} elsif ($ipcount[$a] == 1) {
		print FILE "<tr><td colspan=4>1 hit from: $ipaddr[$a]";
		for ($z = $a+1; $z < $numip; $z++) {
			print FILE ", $ipaddr[$z]";
		}
		print FILE "</td></tr>\n";
		$a = $numip;
	}

}

print FILE "<tr><th>TOTAL</th>";
print FILE "<th>$total</th>";
print FILE "<th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n"; 
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</font></center></body></html>\n";

close(FILE);

# write ip data

open(FILE, ">$logdir/ip.txt") || &file_open_error("ip.txt");

for ($a = 0; $a <= $numip; $a++) {

   if ($ipcount[$a] > 0) {  
	print FILE "$ipaddr[$a]``$ipcount[$a]``xxx\n";
   }

}

close(FILE);

print "<!-- Finished with ip.html -->\n";

} # end sub ip

sub browser {

# get old browser data

open(FILE, "$logdir/browser.txt") || &file_open_error("browser.txt");

@brinfo = <FILE>;
close(FILE);
$numbr = @brinfo;
$newbr = $ENV{'HTTP_USER_AGENT'};
$useragent = $ENV{'HTTP_USER_AGENT'};
$foundmo = 'no';
$foundie = 'no';
@mo = (0,0,0,0);
@ie = (0,0,0,0);
$ver_num = '0';
$brfound = 0;
$total = 0;

# add 1 to current browser

for ($a = 0; $a < $numbr; $a++) {

   ($oldbr, $oldbrcount, $nochop) = split(/``/,$brinfo[$a]);

   for ($z = 1; $z < 5; $z++) {
      if ($oldbr eq "Mozilla$z") {
         $mo[$z-1] = $oldbrcount;
      } elsif ($oldbr eq "Explorer$z") {
         $ie[$z-1] = $oldbrcount;
      }
   }

   if ($oldbr eq 'Lynx') {
      $lynx = $oldbrcount;
   } elsif ($oldbr eq 'Unknown') {
      $unknown = $oldbrcount;
   }

}

for ($a = 0; $a < 100; $a++) {

   if (substr($useragent,$a,7) eq "Mozilla") {
      $brfound = 1;
      $foundmo = 'yes';
      $ver_num = substr($useragent,$a+8,1);
   } elsif (substr($useragent,$a,4) eq "MSIE") {
      $foundmo = 'no';
      $foundie = 'yes';
      $brfound = 1;
      $ver_num = substr($useragent,$a+5,1);
      $a = 100;
   } elsif (substr($useragent,$a,4) eq "Lynx") {
      $foundmo = 'no';
      $lynx++;
      $a = 100;
      $brfound = 1;
   }
}

if ($foundmo eq 'yes') {
   if ($ver_num > 1) {
      $mo[$ver_num-1] ++;
   } else {
      $mo[0]++;
   }
} elsif ($foundie eq 'yes') {
   if ($ver_num > 1) {
      $ie[$ver_num-1] ++;
   } else {
      $ie[0]++;
   }
}

if ($brfound == 0) {
   $unknown++;
}

$total = 0;
for ($a = 0; $a < 4; $a++) {
   $total = $total + $ie[$a] + $mo[$a];
}
$total = $total + $lynx + $unknown;

# get percent, graph width

for ($a = 0; $a < 4; $a++) {

   if ($mo[$a] == 0) {
      $mop[$a] = 0;
      $mog[$a] = 1;
   } else {
      $mop[$a] = sprintf("%.2f", ($mo[$a]/$total) * 100);
      $mog[$a] = int(5*$mop[$a])+1;
   }

   if ($ie[$a] == 0) {
      $iep[$a] = 0;
      $ieg[$a] = 1;
   } else {
      $iep[$a] = sprintf("%.2f", ($ie[$a]/$total) * 100);
      $ieg[$a] = int(5*$iep[$a])+1;
   }
}

if ($lynx == 0) {
   $lynxp = 0;
   $lynxg = 1;
} else {
   $lynxp = sprintf("%.2f", ($lynx/$total) * 100);
   $lynxg = int(5*$lynxp)+1;
}

if ($unknown == 0) {
   $unknownp = 0;
   $unknowng = 1;
} else {
   $unknownp = sprintf("%.2f", ($unknown/$total) * 100);
   $unknowng = int(5*$unknownp)+1;
}

$moto = 0;
$motog = 0;
$motop = 0;
$ieto = 0;
$ietog = 0;
$ietop = 0;

for ($a = 0; $a < 4; $a++) {
   $moto = $moto + $mo[$a];
   $motop = sprintf("%.2f", $motop + $mop[$a]);
   $ieto = $ieto + $ie[$a];
   $ietop = sprintf("%.2f", $ietop + $iep[$a]);
}

$motog = int(5*$motop)+1;
$ietog = int(5*$ietop)+1;

# write browser.html

open(FILE, ">$logdir/browser.html") || &file_open_error("browser.html");

&header("Hits by Browser");
print FILE "<font face=\"comic sans ms\" size=0 color=black>Browser stats reset on $brdate\.</font><p>\n";
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
print FILE "<th>BROWSER</th>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th>\n";

for ($a = 4; $a > 1; $a--) {
   print FILE "<tr><th>Netscape (Mozilla) - ver. $a</th>";
   print FILE "<td align=center>$mo[$a-1]</td>";
   print FILE "<td align=center>$mop[$a-1] %</td>";
   print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
   print FILE "width=\"$mog[$a-1]\"></td></tr>\n";
}

print FILE "<tr><th>Netscape (Mozilla) - other</th>";
print FILE "<td align=center>$mo[0]</td>";
print FILE "<td align=center>$mop[0] %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$mog[0]\"></td></tr>\n\n";

print FILE "<tr><td bgcolor=#ffffff colspan=4>\&nbsp;</td></tr>\n\n";

for ($a = 4; $a > 1; $a--) {
   print FILE "<tr><th>MS Internet Explorer - ver. $a</th>";
   print FILE "<td align=center>$ie[$a-1]</td>";
   print FILE "<td align=center>$iep[$a-1] %</td>";
   print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
   print FILE "width=\"$ieg[$a-1]\"></td></tr>\n";
}

print FILE "<tr><th>MS Internet Explorer - other</th>";
print FILE "<td align=center>$ie[0]</td>";
print FILE "<td align=center>$iep[0] %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$ieg[0]\"></td></tr>\n\n";

print FILE "<tr><td bgcolor=#ffffff colspan=4>\&nbsp;</td></tr>\n\n";

print FILE "<tr><th>Netscape (Mozilla) Total</th>";
print FILE "<td align=center>$moto</td>";
print FILE "<td align=center>$motop %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$motog\"></td></tr>\n";

print FILE "<tr><th>MS Internet Explorer Total</th>";
print FILE "<td align=center>$ieto</td>";
print FILE "<td align=center>$ietop %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$ietog\"></td></tr>\n";

print FILE "<tr><th>Lynx</th>";
print FILE "<td align=center>$lynx</td>";
print FILE "<td align=center>$lynxp %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$lynxg\"></td></tr>\n";

print FILE "<tr><th>Unknown</th>";
print FILE "<td align=center>$unknown</td>";
print FILE "<td align=center>$unknownp %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$unknowng\"></td></tr>\n\n";

print FILE "<tr><td bgcolor=#ffffff colspan=4>\&nbsp;</td></tr>\n\n";

print FILE "<tr><th>TOTAL</th>";
print FILE "<th>$total</th>";
print FILE "<th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n";
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n"; 
print FILE "</font></center></body></html>\n";

# write browser data

open(FILE, ">$logdir/browser.txt") || &file_open_error("browser.txt");

for ($a = 4; $a > 0; $a--) {
   print FILE "Mozilla$a``$mo[$a-1]``xxx\n";
   print FILE "Explorer$a``$ie[$a-1]``xxx\n";
}
print FILE "Lynx``$lynx``xxx\n";
print FILE "Unknown``$unknown``xxx\n";

close(FILE);

print "<!-- Finished with browser.html -->\n";

} # end sub browser

sub os {

# get old OS data

open(FILE, "$logdir/os.txt") || &file_open_error("os.txt");

@osinfo = <FILE>;
close(FILE);
$numos = @osinfo;
$osfound = 0;
$total = 0;

for ($a = 0; $a < $numos; $a++) {

   ($tempos, $temposcount, $nochop) = split(/``/,$osinfo[$a]);

   if ($tempos eq "Windows 95") {
      $win95 = $temposcount;
   } elsif ($tempos eq "Windows NT") {
      $winnt = $temposcount;
   } elsif ($tempos eq "Macintosh") {
      $mac = $temposcount;
   } elsif ($tempos eq "Unix") {
      $unix = $temposcount;
   } elsif ($tempos eq "Windows 3.1") {
      $win31 = $temposcount;
   } elsif ($tempos eq "Win 16") {
      $win16 = $temposcount;
   } elsif ($tempos eq "Unknown") {
      $unknown = $temposcount;
   }

}

# figure out what os they're using

for ($a = 0; $a < 100; $a++) {

   if ((substr($useragent,$a,5) eq "Win95") ||
         (substr($useragent,$a,5) eq "win95") ||
         (substr($useragent,$a,10) eq "Windows 95") ||
         (substr($useragent,$a,10) eq "windows 95")) {
            $win95++;
            $a = 100;
            $osfound = 1;
   }
   elsif ((substr($useragent,$a,3) eq "Mac") ||
         (substr($useragent,$a,3) eq "mac")) {
            $mac++;
            $a = 100;
            $osfound = 1;
   }  
   elsif ((substr($useragent,$a,4) eq "Unix") ||
         (substr($useragent,$a,4) eq "unix") ||
         (substr($useragent,$a,5) eq "Linux") ||
         (substr($useragent,$a,5) eq "linux") ||
         (substr($useragent,$a,4) eq "Irix") ||
         (substr($useragent,$a,4) eq "irix")) {
            $unix++;
            $a = 100;
            $osfound = 1;
   }
   elsif ((substr($useragent,$a,5) eq "WinNT") ||
         (substr($useragent,$a,10) eq "Windows NT") ||
         (substr($useragent,$a,5) eq "winNT") ||
         (substr($useragent,$a,10) eq "windows NT")) {
            $winnt++;
            $a = 100;
            $osfound = 1;
   }         
   elsif ((substr($useragent,$a,5) eq "Win16") ||
         (substr($useragent,$a,6) eq "Win 16") ||
         (substr($useragent,$a,5) eq "win16") ||
         (substr($useragent,$a,6) eq "win 16")) {
            $win16++;
            $a = 100;
            $osfound = 1;
   }
   elsif ((substr($useragent,$a,7) eq "Win 3.1") ||
         (substr($useragent,$a,6) eq "Win3.1") ||
         (substr($useragent,$a,11) eq "Windows 3.1")) {
            $win31++;
            $a = 100;
            $osfound = 1;
   }

}

if ($osfound == 0) {
   $unknown++;
}

$total = $win95 + $winnt + $mac + $unix + $win31 + $win16 + $unknown;

# get percent, graph width

if ($win95 == 0) {
   $win95p = 0;
   $win95g = 1;
} else {
   $win95p = sprintf("%.2f", ($win95/$total) * 100);
   $win95g = int(5*$win95p)+1;
}

if ($winnt == 0) {
   $winntp = 0;
   $winntg = 1;
} else {
   $winntp = sprintf("%.2f", ($winnt/$total) * 100);
   $winntg = int(5*$winntp)+1;
}

if ($mac == 0) {
   $macp = 0;
   $macg = 1;
} else {
   $macp = sprintf("%.2f", ($mac/$total) * 100);
   $macg = int(5*$macp)+1;
}

if ($unix == 0) {
   $unixp = 0;
   $unixg = 1;
} else {
   $unixp = sprintf("%.2f", ($unix/$total) * 100);
   $unixg = int(5*$unixp)+1;
}

if ($win31 == 0) {
   $win31p = 0;
   $win31g = 1;
} else {
   $win31p = sprintf("%.2f", ($win31/$total) * 100);
   $win31g = int(5*$win31p)+1;
}

if ($win16 == 0) {
   $win16p = 0;
   $win16g = 1;
} else {
   $win16p = sprintf("%.2f", ($win16/$total) * 100);
   $win16g = int(5*$win16p)+1;
}

if ($unknown == 0) {
   $unknownp = 0;
   $unknowng = 1;
} else {
   $unknownp = sprintf("%.2f", ($unknown/$total) * 100);
   $unknowng = int(5*$unknownp)+1;
}

# write os.html

open(FILE, ">$logdir/os.html") || &file_open_error("os.html");

&header("Hits by Operating System");
print FILE "<font face=\"comic sans ms\" size=0 color=black>Operating System stats reset on $osdate\.</font><p>\n";
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n"; print FILE "<tr><th>OS</th>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th>\n";

print FILE "<tr><th>Windows 95</th>";
print FILE "<td align=center>$win95</td>";
print FILE "<td align=center>$win95p %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$win95g\"></td></tr>\n";

print FILE "<tr><th>Windows NT</th>";
print FILE "<td align=center>$winnt</td>";
print FILE "<td align=center>$winntp %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$winntg\"></td></tr>\n";

print FILE "<tr><th>Macintosh</th>";
print FILE "<td align=center>$mac</td>";
print FILE "<td align=center>$macp %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$macg\"></td></tr>\n";

print FILE "<tr><th>Unix</th>";
print FILE "<td align=center>$unix</td>";
print FILE "<td align=center>$unixp %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$unixg\"></td></tr>\n";

print FILE "<tr><th>Windows 3.1</th>";
print FILE "<td align=center>$win31</td>";
print FILE "<td align=center>$win31p %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$win31g\"></td></tr>\n";

print FILE "<tr><th>Win 16</th>";
print FILE "<td align=center>$win16</td>";
print FILE "<td align=center>$win16p %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$win16g\"></td></tr>\n";

print FILE "<tr><th>Unknown</th>";
print FILE "<td align=center>$unknown</td>";
print FILE "<td align=center>$unknownp %</td>";
print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
print FILE "width=\"$unknowng\"></td></tr>\n";

print FILE "<tr><th>TOTAL</th>";
print FILE "<th>$total</th>";
print FILE "<th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n";
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</font></center></body></html>\n";

close(FILE);

# write os data

open(FILE, ">$logdir/os.txt") || &file_open_error("os.txt");

print FILE "Windows 95``$win95``xxx\n";
print FILE "Windows NT``$winnt``xxx\n";
print FILE "Macintosh``$mac``xxx\n";
print FILE "Unix``$unix``xxx\n";
print FILE "Windows 3.1``$win31``xxx\n";
print FILE "Win 16``$win16``xxx\n";
print FILE "Unknown``$unknown``xxx\n";
print FILE "Total``$total``xxx\n";

close(FILE);

print "<!-- Finished with os.html -->\n";

} # end sub os

sub referer {

# get old referer data

open(FILE, "$logdir/referer.txt") || &file_open_error("referer.txt");

@rinfo = <FILE>;
close(FILE);
$numr = @rinfo;
$r = $ENV{HTTP_REFERER};

for ($a = 0; $a < 70; $a++) {
	if (substr($r,$a,1) eq '?') {
		$r = substr($r,0,$a);
		$a = 70;
	}
}

$rfound = 0;
$total = 0;
$chopr = $r;
chop($chopr);

# add 1 to current referer

for ($a = 0; $a < $numr; $a++) {

   ($rpage[$a], $rcount[$a], $nochop) = split(/``/,$rinfo[$a]);

   $temprpage = $rpage[$a];
   $choppage = chop($temprpage);

   if ($temprpage eq $r || $choppage eq $r || $chopr eq $temprpage ||
       $temprpage eq "$r\b/" || 
       $temprpage eq "$r\/index.htm" || $temprpage eq "$r\/index.html" ||
       $temprpage eq "$r\/index.shtml" || $temprpage eq "$r\/index.chtml" ||
       $temprpage eq "$chopr\/index.htm" || $temprpage eq "$chopr\/index.html" ||
       $temprpage eq "$chopr\/index.shtml" || $temprpage eq "$chopr\/index.chtml" ||
       "$temprpage\/" eq $r || "$temprpage\/index.htm" eq $r ||
       "$temprpage\/index.html" eq $r || "$temprpage\/index.shtml" eq $r || 
       "$temprpage\/index.chtml" eq $r || "$choppage\/index.htm" eq $r ||
       "$choppage\/index.html" eq $r || "$choppage\/index.shtml" eq $r ||
       "$choppage\/index.chtml" eq $r) {
      $rcount[$a] ++;
      $rfound = 1;
   }

   $total = $total + $rcount[$a];

}

# if this referer is new, create a new piece of data for it

if ($rfound == 0) {
   $rpage[$numr] = $r;
   $rcount[$numr] = 1;
   $numr++;
   $total++;
}

# the famous "Gugliotta Bubliotta" sort

for ($a = 0; $a < $numr; $a++) {
   for ($b = ($numr - 1); $b > $a; $b--) {

      if ($rcount[$b] > $rcount[$b-1]) {
         $temp3 = $rcount[$b-1];
         $rcount[$b-1] = $rcount[$b];
         $rcount[$b] = $temp3;
         $temp4 = $rpage[$b-1];
         $rpage[$b-1] = $rpage[$b];
         $rpage[$b] = $temp4;
      }

   }
}

# get percent, graph width

for ($a = 0; $a < $numr; $a++) {

        $rp[$a] = sprintf("%.2f", ($rcount[$a]/$total) * 100);
        $rg[$a] = int(5*$rp[$a])+1;

}

# write referer html file

open(FILE, ">$logdir/referer.html") || &file_open_error("referer.html");

&header("Hits by Referer");
print FILE "<font face=\"comic sans ms\" size=0 color=black>Referer stats reset on $redate\.</font><p>\n";
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n\n"; 
print FILE "<tr><th>REFERER</th>";
print FILE "<td><font color=\"#000066\">.</font></td>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th>\n\n";

for ($a = 0; $a < $numr; $a++) {

        if ($rcount[$a] > 1) {

		if ($rpage[$a] eq substr($rpage[$a],0,50)) {
	                print FILE "<tr><th>$rpage[$a]</th>\n";
		} else {
			$temp99 = substr($rpage[$a],0,50);
			print FILE "<tr><th><a href=\"javascript:alert('$rpage[$a]')\">$temp99</a></th>\n";
		}
		print FILE "<td align=center><a href=\"$rpage[$a]\" target=_top>Go</a></td>\n";
                print FILE "<td align=center>$rcount[$a]</td>\n";
                print FILE "<td align=center>$rp[$a]%</td>\n";
                print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
                print FILE "width=\"$rg[$a]\"></td></tr>\n\n";

        } elsif ($rcount[$a] == 1) {
                print FILE "<tr><td colspan=5>1 hit from: ";
                if ($rpage[$a] eq substr($rpage[$a],0,50)) {
                        print FILE "$rpage[$a]";
                } else {
                        $temp99 = substr($rpage[$a],0,50);
                        print FILE "<a href=\"javascript:alert('$rpage[$a]')\">$temp99</a>";
                }
                for ($z = $a+1; $z < $numr; $z++) {
	                if ($rpage[$z] eq substr($rpage[$z],0,50)) {
        	                print FILE ", $rpage[$z]";
                	} else {
                        	$temp99 = substr($rpage[$z],0,50);
                        	print FILE ", <a href=\"javascript:alert('$rpage[$z]')\">$temp99</a>";
                	}
		}
                print FILE "</td></tr>\n";
                $a = $numr;
        }

}

print FILE "<tr><th>TOTAL</th>";
print FILE "<td><font color=\"#000066\">.</font></td>";
print FILE "<th>$total</th>";
print FILE "<th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n";
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</font></center></body></html>\n";

close(FILE);

# write referer data

open(FILE, ">$logdir/referer.txt") || &file_open_error("referer.txt");

for ($a = 0; $a <= $numr; $a++) {

   if ($rcount[$a] > 0) {
        print FILE "$rpage[$a]``$rcount[$a]``xxx\n";
   }

}

close(FILE);

print "<!-- Finished with referer.html -->\n";

} # end sub referer

sub server {

$total = 0;

open(FILE, "$logdir/domain.txt") || &file_open_error("domain.txt");

@dinfo = <FILE>;
close(FILE);

for ($a = 0; $a < 248; $a++) {

	($domain_ex[$a], $domain_real[$a], $nochop) = split(/``/,$dinfo[$a]);

}

open(FILE, "$logdir/server.txt") || &file_open_error("server.txt");

@sinfo = <FILE>;
close(FILE);

(@dcount) = split(/``/,$sinfo[0]);

@domain_parts = split(/\./,$ENV{REMOTE_HOST});
$temp_number = @domain_parts;
$find_me ="\U$domain_parts[$temp_number - 1]";

# count this and write server.txt

open(FILE, ">$logdir/server.txt") || &file_open_error("server.txt");

for ($a = 0; $a < 248; $a++) {
	if ($domain_ex[$a] eq "$find_me") {
		$dcount[$a]++;
	}

	print FILE "$dcount[$a]";
	print FILE "``";
	$total += $dcount[$a];
}

print FILE "xx";
close(FILE);

# bubbles again

for ($a = 0; $a < 248; $a++) {
   for ($b = 247; $b > $a; $b--) {

      if ($dcount[$b] > $dcount[$b-1]) {
         $tempaa = $domain_ex[$b-1];
         $domain_ex[$b-1] = $domain_ex[$b];
         $domain_ex[$b] = $tempaa;
         $tempbb = $dcount[$b-1];
         $dcount[$b-1] = $dcount[$b];
         $dcount[$b] = $tempbb;
         $tempcc = $domain_real[$b-1];
         $domain_real[$b-1] = $domain_real[$b];
         $domain_real[$b] = $tempcc;
      }

   }
}

# get percent, graph width

if ($total > 0) {

	for ($a = 0; $a < 248; $a++) {
        	$dp[$a] = sprintf("%.2f", ($dcount[$a]/$total) * 100);
        	$dg[$a] = int(5*$dp[$a]) + 1;
	}

}

# write domain html file

open(FILE, ">$logdir/server.html") || &file_open_error("server.html");

&header("Hits by Domain Extension");
print FILE "<table width=90% cellpadding=3 cellspacing=0 border=1 bgcolor=#000066>\n";
print FILE "<tr><th>EXTENSION</th>";
print FILE "<th>ACTUAL</th>";
print FILE "<th width=15%>HITS</th>";
print FILE "<th width=15%>PERCENT</th>";
print FILE "<th>GRAPH</th>\n";

for ($a = 0; $a < 248; $a++) {

        if ($dcount[$a] > 0) {

                print FILE "<tr><th>$domain_ex[$a]</th>";
		print FILE "<th>$domain_real[$a]</th>";
                print FILE "<td align=center>$dcount[$a]</td>";
                print FILE "<td align=center>$dp[$a]%</td>";
                print FILE "<td align=left><img src=\"white.jpg\" height=\"10\" ";
                print FILE "width=\"$dg[$a]\"></td></tr>\n";
	
	}

}

print FILE "<tr><th>TOTAL</th>";
print FILE "<td><font color=\"#000066\">.</font></td>";
print FILE "<th>$total</th>";
print FILE "<th>100.00%</th>";
print FILE "<td><font color=\"#000066\">.</font></td></tr>\n";
print FILE "</table><p>\n";
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</font></center></body></html>\n";

close(FILE);

print "<!-- Finished with server.html -->\n";

} # end sub server

sub log {

# get old logfile

open(FILE, "$logdir/log.htm") || &file_open_error("log.htm");
@lines = <FILE>;
close(FILE);
$sizelines = @lines;

$counter_max = 1;

# add current hit to the log

open (FILE, ">$logdir/log.htm") || &file_open_error("log.htm");
        
for ($a = 0; $a <= $sizelines; $a++) {
        
	$_ = $lines[$a];

	if (/<!--begin-->/) {
		print FILE "<!--begin-->\n";
		print FILE "<tr><td align=center colspan=3>";
		print FILE "<font face=arial size=+1><b>$date</b></font></td></tr>\n";
		print FILE "<tr><td align=center><font face=arial size=2>";
		print FILE "Name Server<br>";
		if ($ENV{REMOTE_HOST}) {
			print FILE "<b>$ENV{REMOTE_HOST}</b></font></td>\n";
		} else {
			print FILE "<b>Unknown</b></font></td>\n";
		}
		print FILE "<td align=center><font face=arial size=2>";
		print FILE "IP Address<br>";
		if ($ENV{REMOTE_ADDR}) {
			print FILE "<b>$ENV{REMOTE_ADDR}</b></font></td>\n";
		} else {
			print FILE "<b>Unknown</b></font></td>\n";
		}
		print FILE "<td align=center><font face=arial size=2>";
		print FILE "User Agent<br>";
		if ($ENV{HTTP_USER_AGENT}) {
			print FILE "<b>$ENV{HTTP_USER_AGENT}</b></td></tr>\n";
		} else {
			print FILE "<b>Unknown</b></td></tr>\n";
		}
		if ($ENV{HTTP_REFERER}) {
			print FILE "<tr><td align=center colspan=3><font face=arial size=2>";
			print FILE "<b><a href=\"javascript:alert('$ENV{HTTP_REFERER}')\">Referring Page</a>\n";
			print FILE "(<a href=\"$ENV{HTTP_REFERER}\">Go</a>)</b></td></tr>\n";
		}
		print FILE "<!--next-->\n\n";
		print FILE "<tr><td colspan=3 bgcolor=#ffffff><font face=arial size=0>";
		print FILE "\&nbsp;</td></tr>\n";

	} elsif (/<!--next-->/) {

		print FILE "<!--next-->\n";
		$counter_max++;
		if ($counter_max == $max) {
			$a = $sizelines;
		}

	} elsif (/<!--end-->/) {
		$a = $sizelines;
	} else {
		print FILE "$_";
	}

}

print FILE "<!--end-->\n";
print FILE "</table><p>\n";
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td><a href=\"$logurl/index.html\">RobLog Main</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</font></center></body></html>\n";

close(FILE);

print "<!-- Finished with log.htm -->\n";

} # end sub log

sub index {

open(FILE, ">$logdir/index.html") || &file_open_error("index.html");

print FILE "<html>\n";
print FILE "<head><title>RobLog v4.02 Main Page</title></head>\n\n";
print FILE "<!--\n";
print FILE "RobLog v4.02 Copyright 1998 by Rob Eisler\n";
print FILE "eislerr\@tdi.uregina.ca\n";
print FILE "http://tdi.uregina.ca/~eislerr\n";
print FILE "-->\n\n";
print FILE "<body bgcolor=#ffffff link=#00ff00 vlink=#00ff00 text=#000000>\n"; 
print FILE "<center>\n\n";
print FILE "<font face=arial size=5><b>RobLog v4.02 Main</b></font><br>\n";
print FILE "<font face=arial size=2><b>with RobAdmin</b></font><p>\n";
print FILE "<font face=arial>\n";
print FILE "Last Hit: <b>$date</b>.\n";
print FILE "</font>\n";
print FILE "<p>\n";
print FILE "<table border=1 bgcolor=#000066 cellpadding=8>\n";
print FILE "<tr><td align=center><a href=\"$logurl/log.htm\">Log File</a></td>\n";
print FILE "<td align=center><a href=\"$logurl/weekday.html\">Hits by Weekday</a></td>\n";
print FILE "<td align=center><a href=\"$logurl/hour.html\">Hits by Hour</a></a></td>\n";
print FILE "<td align=center><a href=\"$logurl/ip.html\">Hits by IP</a> </td>\n";

print FILE "<td align=center rowspan=4 bgcolor=#ffffff>\n";
print FILE "<table border=0>\n";
print FILE "<tr><td align=center bgcolor=black>\n";
print FILE "<a href=\"http://tdi.uregina.ca/~eislerr\"><img src=\"roblog.gif\" border=0></a><br>\n";
print FILE "<a href=\"http://tdi.uregina.ca/~eislerr\"><img src=\"four.gif\"border=0></a></td></tr>\n";
print FILE "</table>\n";
print FILE "</td></tr>\n";

print FILE "<tr><td align=center width=20%><a href=\"$logurl/browser.html\">Hits by Browser</a></td>\n";
print FILE "<td align=center width=20%><a href=\"$logurl/os.html\">Hits by OS</a></td>\n"; 
print FILE "<td align=center width=20%><a href=\"$logurl/referer.html\">Hits by Referer</a></td>\n";
print FILE "<td align=center width=20%><a href=\"$logurl/server.html\">Hits by Domain</a></td></tr>\n";

print FILE "<tr><td align=center colspan=2><a href=\"$logurl/admin.html\">RobAdmin</a></td>\n";
print FILE "<td align=center colspan=2><a href=\"mailto:eislerr\@tdi.uregina.ca\">E-mail Rob</a></td></tr>\n";
print FILE "</table>\n";
print FILE "</center></body></html>\n";

close(FILE);

print "<!-- Finished with index.html -->\n";

} # end sub index

sub get_data {

	open(FILE, "$logdir/pwd.txt") || &file_open_error("pwd.txt");

	@pwdinfo = <FILE>;
	close(FILE);

	($p, $max, $ipdate, $brdate, $osdate, $redate, $nochop) = split(/``/,$pwdinfo[0]);

} # end sub get_data

sub get_date {

        @days = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
        @months = ('January','February','March','April','May','June','July','August','September','October','November','December');

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time + (3600*$timeoffset));

	$savehour = $hour;
	$hour = "0$hour" if ($hour < 10);
	$min = "0$min" if ($min < 10);
	$sec = "0$sec" if ($sec < 10);
	$year = 1900 + $year;

	$date = "$days[$wday], $months[$mon] $mday, $year at $hour\:$min\:$sec";

} # end sub get_date

sub header {

	local($passed) = @_;

	print FILE "<html>\n";
	print FILE "<head><title>RobLog v4.02 - $passed</title></head>\n\n";
	print FILE "<!--\n";
	print FILE "RobLog v4.02 Copyright 1998 by Rob Eisler\n";
	print FILE "eislerr\@tdi.uregina.ca\n";
	print FILE "http://tdi.uregina.ca/~eislerr\n";
	print FILE "http://tdi.uregina.ca/~eislerr/cgi/roblog\n";
	print FILE "-->\n\n";
	print FILE "<body bgcolor=#ffffff link=#00ff00 vlink=#00ff00 text=#dddddd>\n";
	print FILE "<center>\n";
	print FILE "<font face=arial size=5 color=black>RobLog v4.02 - $passed</font><p>\n";

} # end sub header

sub check_url {

	local($check_referer) = 1;
   
	if ($ENV{'HTTP_REFERER'}) {
		foreach $referer (@referers) {
			if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
				exit;
			}
		}
	}	 
	if ($ENV{'REMOTE_ADDR'}) {
		foreach $referer (@referers) {
			if ($ENV{'REMOTE_ADDR'} =~ m|([^/]*)$referer|i) {
				exit;
			}
		}
	} 
	if ($ENV{'REMOTE_HOST'}) {
		foreach $referer (@referers) {
			if ($ENV{'REMOTE_HOST'} =~ m|([^/]*)$referer|i) {
				exit;
			}
		}
	}
} # end sub check_url

sub file_open_error {

	local($file) = @_;
	print "<!-- Error! RobLog was unable to open $file -->\n";
	print "<!-- RobLog v4.02 NOT Successfully Completed! -->\n";
	print "<font face=arial size=2>[ RobLog Error - ";
	print "Unable to open $file ]</font><br>\n";
	exit;

} # end sub file_open_error

### end of code ###
